//---------------------------------------------------------------------------

#include <vcl.h>
#include <sysdyn.h>
#pragma hdrstop
#include <Math.h>
#include "MainUnit.h"
#include "CADInspUnit.h"
#include "AboutUnit.h"
#include "LibShowUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cad"
#pragma resource "*.dfm"
TMainFrm *MainFrm;
//---------------------------------------------------------------------------
__fastcall TMainFrm::TMainFrm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::New1Click(TObject *Sender)
{
  NewDrawingBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::NewDrawingBtnClick(TObject *Sender)
{
  if (MessageDlg("Begin a new drawing?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo  , 0) == mrYes)
    MyCAD1->DeleteAllShapes();


}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::Load1Click(TObject *Sender)
{
 CADInspFrm->ComponentComboBox1->Root=MainFrm->MyCAD1;
 CADInspFrm->ComponentInspector1->Instance=MainFrm->MyCAD1;

 OpenDialog1->InitialDir = ExtractFilePath(Application->ExeName) + "samples\\";
   if (OpenDialog1->Execute()) {

    if (FileExists(OpenDialog1->FileName))
      if (MyCAD1->IsTCADFile(OpenDialog1->FileName))
      {
        if (!MyCAD1->LoadFromFile(OpenDialog1->FileName))
          ShowMessage("Error when read file");
      }
      else
        ShowMessage(OpenDialog1->FileName + "is not a TCAD format file!");
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::Save1Click(TObject *Sender)
{
 if (SaveDialog1->Execute())
  if (MyCAD1->SaveToFile(SaveDialog1->FileName))
    ShowMessage("MyCAD1 has been saved to "+SaveDialog1->FileName);

}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::BitmapFile1Click(TObject *Sender)
{
 MyCAD1->SaveToBmp("C:\\TestCAD.Bmp");
  ShowMessage("MyCAD1 has been saved to c:\\TestCAD.bmp!");
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::WmfFile1Click(TObject *Sender)
{
  MyCAD1->SaveToWmf("C:\\TestCAD.Wmf");
  ShowMessage("MyCAD1 has been saved to c:\\TestCAD.Wmf!");
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::JpegFle1Click(TObject *Sender)
{
   MyCAD1->SaveToJpg("C:\\TestCAD.Jpg",80);
  ShowMessage("MyCAD1 has been saved to c:\\TestCAD.Jpg!");
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::LoadFromStream1Click(TObject *Sender)
{
  ShowMessage("You can load MyCAD from  database !  function  TMyCAD.LoadFromStream(Stream: TStream):Boolean;");
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SaveToStream1Click(TObject *Sender)
{
  ShowMessage("You can use this function to Save MyCAD to database !  function TMyCAD.SaveToStream(Stream: TStream):Boolean;");

}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::N3Click(TObject *Sender)
{
 ShellExecute(Handle, "open",    "http://www.codeidea.com/html/buynow.htm",
    NULL, NULL, SW_SHOWNORMAL);

}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::GroupShapes1Click(TObject *Sender)
{
  MyCAD1->GroupWorkingShape();
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::unGroup1Click(TObject *Sender)
{
 if (MyCAD1->GetSelectedShapesCount() == 1 )
    MyCAD1->UnGroupShape(MyCAD1->GetSelectedShape(),true);
  else
    ShowMessage("No shape selected or more shapes selected!");

}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SendToBack1Click(TObject *Sender)
{
 MyCAD1->SendToBack(MyCAD1->GetSelectedShape(),true);
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::BringToFront1Click(TObject *Sender)
{
 MyCAD1->BringToFront(MyCAD1->GetSelectedShape(),true);
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::Copy1Click(TObject *Sender)
{
 MyCAD1->Copy();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::Paste1Click(TObject *Sender)
{
 MyCAD1->Paste();        
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::Cut1Click(TObject *Sender)
{
  MyCAD1->Cut();

}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::AlignLeft1Click(TObject *Sender)
{
  MyCAD1->AlignLeft();        
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::AlignRight1Click(TObject *Sender)
{
  MyCAD1->AlignRight();        
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::AlignTop1Click(TObject *Sender)
{
  MyCAD1->AlignTop();
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::AlignBottom1Click(TObject *Sender)
{
  MyCAD1->AlignBottom();        
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::BeMouseNoShape1Click(TObject *Sender)
{
  MyCAD1->ShapeTool = SpSelecting;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AboutTCAD1Click(TObject *Sender)
{
 AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::Visitcodeideacom1Click(TObject *Sender)
{
 ShellExecute(Handle, "open",    "http://www.codeidea.com",
    NULL, NULL, SW_SHOWNORMAL);

}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::BuyNow1Click(TObject *Sender)
{
 ShellExecute(Handle, "open",    "http://www.codeidea.com/html/buynow.htm",
    NULL, NULL, SW_SHOWNORMAL);
        
}
//---------------------------------------------------------------------------
void __fastcall TMainFrm::SpeedButton6Click(TObject *Sender)
{
 ShellExecute(Handle, "open",    "http://www.codeidea.com/html/buynow.html",
    NULL, NULL, SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SelectBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpSelecting;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpLineBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpLine;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpRulelineBtnClick(TObject *Sender)
{
  MyCAD1->ShapeTool = SpRuleLine;        
}
//---------------------------------------------------------------------------



void __fastcall TMainFrm::SpEllipseBtnClick(TObject *Sender)
{
  MyCAD1->ShapeTool = SpEllipse;        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpRectangleBtnClick(TObject *Sender)
{
 MyCAD1->ShapeTool = SpRectangle;        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpPolyLineBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpPolyLine;        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpPolygonBtnClick(TObject *Sender)
{
 MyCAD1->ShapeTool = SpPolygon;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpElliArcBtnClick(TObject *Sender)
{
MyCAD1->ShapeTool = SpElliArc;
}
//---------------------------------------------------------------------------


void __fastcall TMainFrm::SpeedButton1Click(TObject *Sender)
{
MyCAD1->ShapeTool = SpPolyBezier;
}
//---------------------------------------------------------------------------


void __fastcall TMainFrm::SpTextBtnClick(TObject *Sender)
{
  MyCAD1->ShapeTool = SpText;
}
//---------------------------------------------------------------------------













void __fastcall TMainFrm::SpImageBtnClick(TObject *Sender)
{
 MyCAD1->ShapeTool = SpImage;        
}
//---------------------------------------------------------------------------


void __fastcall TMainFrm::SaveBtnClick(TObject *Sender)
{
  Save1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::PasteClick(TObject *Sender)
{
  Paste1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::CutBtnClick(TObject *Sender)
{
 Cut1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::CopyBtnClick(TObject *Sender)
{
  Copy1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::LoadBtnClick(TObject *Sender)
{
 Load1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::GroupBtnClick(TObject *Sender)
{
  GroupShapes1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::ungroupBtnClick(TObject *Sender)
{
  unGroup1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::alBtnClick(TObject *Sender)
{
  AlignLeft1Click(Sender); 
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::arBtnClick(TObject *Sender)
{
 AlignRight1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AtBtnClick(TObject *Sender)
{
  AlignTop1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AbBtnClick(TObject *Sender)
{
 AlignBottom1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::BringtoBtnClick(TObject *Sender)
{
 BringToFront1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SendtoBtnClick(TObject *Sender)
{
SendToBack1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpeedButton4Click(TObject *Sender)
{
 MyCAD1->DragMode = dgHorz;        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpeedButton5Click(TObject *Sender)
{
 MyCAD1->DragMode = dgVert;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpeedButton7Click(TObject *Sender)
{
  MyCAD1->DragMode = dgBoth;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpeedButton9Click(TObject *Sender)
{
 MyCAD1->GridOperation->GridType=gLine;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpeedButton8Click(TObject *Sender)
{
MyCAD1->GridOperation->GridType=gPixel;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::ZoomCmbBoxChange(TObject *Sender)
{
switch ( ZoomCmbBox->ItemIndex ){
case 0:
       MyCAD1->Zoom=0.5;
       break;
case 1:
       MyCAD1->Zoom=0.75;
       break;
case 2:
       MyCAD1->Zoom=1;
       break;
case 3:
       MyCAD1->Zoom=1.1;
       break;
case 4:
       MyCAD1->Zoom=1.3;
       break;
case 5:
      MyCAD1->Zoom=2.0;
      break;
}
 CenterCAD();
}
//---------------------------------------------------------------------------

void TMainFrm::CenterCAD()
{

 MyCAD1->Left = (ScrollBox1->Width - MyCAD1->Width) / 2;
  MyCAD1->Top = (ScrollBox1->Height - MyCAD1->Height) / 2;
}


void __fastcall TMainFrm::SpeedButton14Click(TObject *Sender)
{
 ShellExecute(Handle, "open",    "http://www.codeidea.com/html/buynow.htm",
    NULL, NULL, SW_SHOWNORMAL);        
}
//---------------------------------------------------------------------------


void __fastcall TMainFrm::Line2Click(TObject *Sender)
{
  TMyPoint  ThePoints[2];
  ThePoints[0]= MyPoint(231, 211);
  ThePoints[1]= MyPoint(40, 50);
  MyCAD1->AddShapeByCode(MyCAD1,SpLine, "LineShape",ThePoints,1,0,"");
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::RuleLine2Click(TObject *Sender)
{
TMyPoint  ThePoints[2];
ThePoints[0]= MyPoint(131,41);
ThePoints[1]= MyPoint(140,150);
MyCAD1->AddShapeByCode(MyCAD1,SpRuleLine, "RuleLineShape", ThePoints,1,0,"");

}
//---------------------------------------------------------------------------




void __fastcall TMainFrm::EllipseClick(TObject *Sender)
{
TMyPoint  ThePoints[4];
ThePoints[0]= MyPoint(231, 211);
ThePoints[1]= MyPoint(340,211);
ThePoints[2]= MyPoint(340, 350);
ThePoints[3]=MyPoint(231,350);
MyCAD1->AddShapeByCode(MyCAD1,SpEllipse, "EllipseShape",  ThePoints,3,0,"");

}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::Rectangle1Click(TObject *Sender)
{
 TMyPoint  ThePoints[4];
 ThePoints[0]= MyPoint(290,211);
 ThePoints[1]= MyPoint(380,211);
 ThePoints[2]= MyPoint(380,270);
 ThePoints[3]= MyPoint(290,270);
 MyCAD1->AddShapeByCode(MyCAD1,SpRectangle, "RectangleShape",  ThePoints,3,30 * 3.14159 / 180,"");
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::PolyLinebyarray1Click(TObject *Sender)
{
TMyPoint  ThePoints[4];

ThePoints[0] = MyPoint(190, 11);
ThePoints[1] = MyPoint(180, 70);
ThePoints[2] = MyPoint(210, 10);
ThePoints[3] = MyPoint(210, 190);
MyCAD1->AddShapeByCode(MyCAD1,SpPolyLine, "PolyLineShape",  ThePoints,3,0,"");
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::Polygonbyarray1Click(TObject *Sender)
{
TMyPoint  ThePoints[4];

ThePoints[0] =MyPoint(390, 11);
ThePoints[1] = MyPoint(380, 70);
ThePoints[2] = MyPoint(210, 10);
ThePoints[3] = MyPoint(110, 190);
MyCAD1->AddShapeByCode(MyCAD1,SpPolygon, "PolygonShape",  ThePoints,3,0,"");
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::ext1Click(TObject *Sender)
{
TMyPoint  ThePoints[4];

 ThePoints[0]= MyPoint(290,211);
 ThePoints[1]= MyPoint(380,211);
 ThePoints[2]= MyPoint(380,270);
 ThePoints[3]= MyPoint(290,270);

  MyCAD1->Font->Size = 14;

MyCAD1->Font->Name="Arial";
  MyCAD1->AddShapeByCode(MyCAD1,SpText, "TextShape4", ThePoints,3,0,/*30 * 3.14159/ 180,*/
   "test Text, rotated 30.");

}
//---------------------------------------------------------------------------


void __fastcall TMainFrm::DeSelectAllShapesByCode1Click(TObject *Sender)
{
  MyCAD1->DeSelectedAllShapesByCode();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SelectShapeByCode1Click(TObject *Sender)
{
  MyCAD1->SelectShapeByCode(1,true);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::FormShow(TObject *Sender)
{
 CADInspFrm->ComponentComboBox1->Root=MainFrm->MyCAD1;
 CADInspFrm->ComponentInspector1->Instance=MainFrm->MyCAD1;

 CADInspFrm->Show();
 CenterCAD();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1ActionToolToSelecting()
{
  SelectBtn->Down = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
if (ZoomIn->Down || ZoomOut->Down)
 {
     MyCAD1->Canvas->Brush->Style=bsClear;
     MyCAD1->Canvas->Pen->Mode=pmXor;
     MyCAD1->Canvas->Pen->Style=psDot ;
     MyCAD1->Canvas->Pen->Color=clBlack;
     mOrg=MyPoint(X,Y);
     mDes=mOrg;
     mDown=true;
     MyCAD1->ShapeTool=SpClose;
 }

if (DragBtn->Down)
{
  mOrg=MyPoint(X,Y);
  mDes=mOrg;
  mDown=true;
  MyCAD1->ShapeTool=SpClose;
}
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{

 if (ZoomIn->Down || ZoomOut->Down )
 {
  if (mDown)
  {
    MyCAD1->Canvas->Rectangle((int)(mOrg.X),(int)(mOrg.Y),(int)(mDes.X),(int)(mDes.Y));
    MyCAD1->Canvas->Brush->Style=bsClear;
    MyCAD1->Canvas->Pen->Mode=pmXor;
    MyCAD1->Canvas->Pen->Style=psDot ;
    MyCAD1->Canvas->Pen->Color=clRed;
    mDes.X=X;
    mDes.Y=Y;

    MyCAD1->Canvas->Rectangle((int)(mOrg.X),(int)(mOrg.Y),(int)(mDes.X),(int)(mDes.Y));
    }
  }
 else


 if (mDown)
 {

   if ((MyCAD1->Left+MyCAD1->Width > ScrollBox1->Width) || (MyCAD1->Left<0))  
  {
    if (X-mOrg.X < 0)
    {
     if ( MyCAD1->Left +MyCAD1->Width > ScrollBox1->Width)
        if  (MyCAD1->Left +MyCAD1->Width +(X -mOrg.X) <  ScrollBox1->Width)
          MyCAD1->Left = ScrollBox1->Width - MyCAD1->Width;
        else
            MyCAD1->Left=  MyCAD1->Left +(X-mOrg.X);
    }
    else
    if   (MyCAD1->Left<0)
    {
     if  ( MyCAD1->Left +(X-mOrg.X) >0)
       MyCAD1->Left = 0;
     else
       MyCAD1->Left =  MyCAD1->Left +(X-mOrg.X);
     };
  };


 if  ((MyCAD1->Top +MyCAD1->Height > ScrollBox1->Height) || (MyCAD1->Top <0))
  {
    if (Y-mOrg.Y < 0 )
    {
     if (MyCAD1->Top +MyCAD1->Height > ScrollBox1->Height)
        if  (MyCAD1->Top +MyCAD1->Height +(Y - mOrg.Y) <  ScrollBox1->Height)
          MyCAD1->Top = ScrollBox1->Height - MyCAD1->Height;
        else
            MyCAD1->Top = MyCAD1->Top +(Y-mOrg.Y);
    }
    else
    if  (MyCAD1->Top < 0)
    {
     if  (MyCAD1->Top +(Y-mOrg.Y) >0)
       MyCAD1->Top = 0;
     else
        MyCAD1->Top =  MyCAD1->Top +(Y-mOrg.Y);
     };
  };

 }
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 int L;

if (ZoomIn->Down)
{
 mDown= false;
 X = mOrg.X +( X - mOrg.X )/ 2 ;
 Y = mOrg.Y +( Y - mOrg.Y )/ 2 ;
 MyCAD1->Zoom=MyCAD1->Zoom * 1.2;
 if ( MyCAD1->Width <= ScrollBox1->Width)
    MyCAD1->Left = (ScrollBox1->Width - MyCAD1->Width) / 2;
  else
    {
     L = (int)(ScrollBox1->Width / 2  - X *1.2);
     if (L > 0)
          MyCAD1->Left = 0 ;
         else
          MyCAD1->Left = L;
    }

 if (MyCAD1->Height <=ScrollBox1->Height)
    MyCAD1->Top = (ScrollBox1->Height - MyCAD1->Height) / 2;
  else
   {
     L= (int)(ScrollBox1->Height / 2  - Y *1.2);
    if (L > 0)
        MyCAD1->Top = 0 ;
     else
        MyCAD1->Top = L ;
   }
 ZoomCmbBox->Text= IntToStr((int)(MyCAD1->Zoom*100))+'%';
}

if (ZoomOut->Down)
{
 mDown= false;
 MyCAD1->Zoom=MyCAD1->Zoom * 0.8;
 if ( MyCAD1->Width <=ScrollBox1->Width)
  MyCAD1->Left = (ScrollBox1->Width - MyCAD1->Width) / 2;
  else
  {
   L= (int)(ScrollBox1->Width / 2  - X *0.8);
   if (L > 0)
       MyCAD1->Left = 0 ;
     else
       MyCAD1->Left = L ;
   }

 if (MyCAD1->Height <=ScrollBox1->Height)
  MyCAD1->Top = (ScrollBox1->Height - MyCAD1->Height) / 2 ;
  else
  {
   L= (int)(ScrollBox1->Height / 2  - Y *0.8);
    if (L > 0)
        MyCAD1->Top = 0;
     else
        MyCAD1->Top = L;
   }
 ZoomCmbBox->Text= IntToStr((int)(MyCAD1->Zoom*100))+'%';
}



if (DragBtn->Down )
{
  mDown = false;
//  MyCAD1->ShapeTool = SpSelecting;
}

  Delete1->Enabled = MyCAD1->GetSelectedShapesCount() > 0;
  BringToFront2->Enabled = MyCAD1->GetSelectedShapesCount() > 0;
  SendToBack2->Enabled = MyCAD1->GetSelectedShapesCount() > 0;
  BringtoBtn->Enabled = BringToFront2->Enabled;
  SendtoBtn->Enabled = SendToBack2->Enabled;

  Group1->Enabled = MyCAD1->GetSelectedShapesCount() > 1;
  UnGroup2->Enabled = MyCAD1->GetSelectedShapesCount() == 1;
  GroupBtn->Enabled = Group1->Enabled;
  ungroupBtn->Enabled = UnGroup2->Enabled;

  if (MyCAD1->GetSelectedShape() != NULL)
 {
    Lock1->Visible = true;
    UnLock1->Visible = true;

    Lock1->Enabled = ! MyCAD1->GetSelectedShape()->Locked;
    UnLock1->Enabled = MyCAD1->GetSelectedShape()->Locked;

 }
  else
 {
    Lock1->Visible = false;
    UnLock1->Visible = false;
}
  AtBtn->Enabled = MyCAD1->GetSelectedShapesCount() > 1;
  alBtn->Enabled = AtBtn->Enabled;
  arBtn->Enabled = AtBtn->Enabled;
  AbBtn->Enabled = AtBtn->Enabled;

  CADInspFrm->ComponentComboBox1->Root=MainFrm->MyCAD1;
   if (MainFrm->MyCAD1->GetSelectedShape() == NULL)
   CADInspFrm->ComponentComboBox1->Instance=MainFrm->MyCAD1;
  else
   CADInspFrm->ComponentComboBox1->Instance=MainFrm->MyCAD1->GetSelectedShape();
 //CADInspFrm->ComponentInspector1->Instance=CADInspFrm->ComponentComboBox1->Instance;
}
//---------------------------------------------------------------------------


void __fastcall TMainFrm::ShowTCAD1Click(TObject *Sender)
{
 CADInspFrm->Show();
}
//---------------------------------------------------------------------------









void __fastcall TMainFrm::Delete1Click(TObject *Sender)
{
  DeleteBtnClick(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::Group1Click(TObject *Sender)
{
  GroupShapes1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::UnGroup2Click(TObject *Sender)
{
unGroup1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SendToBack2Click(TObject *Sender)
{
  SendToBack1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::BringToFront2Click(TObject *Sender)
{
  BringToFront1Click(Sender);        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::Lock1Click(TObject *Sender)
{
  MyCAD1->LockUnLockforShapes(MyCAD1->GetSelectedShape(),true);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::UnLock1Click(TObject *Sender)
{
  MyCAD1->LockUnLockforShapes(MyCAD1->GetSelectedShape(),false);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::DeleteBtnClick(TObject *Sender)
{
  MyCAD1->DeleteSelectedShapes();
   CADInspFrm->ComponentComboBox1->Root=MainFrm->MyCAD1;
  CADInspFrm->ComponentComboBox1->Instance=MainFrm->MyCAD1;
  //CADInspFrm->ComponentInspector1->Instance=CADInspFrm->ComponentComboBox1->Instance;

}
//---------------------------------------------------------------------------



void __fastcall TMainFrm::FormCreate(TObject *Sender)
{
  DoubleBuffered = true;
  ScrollBox1->DoubleBuffered = true;

}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::RotateSelectBtnClick(TObject *Sender)
{
 MyCAD1->ShapeTool=SpRotateSelecting;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpeedButton3Click(TObject *Sender)
{
  MyCAD1->ShapeTool = SpLineLinkLine;
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpeedButton2Click(TObject *Sender)
{
  MyCAD1->ShapeTool = SpLinkLine;
}
//---------------------------------------------------------------------------


void __fastcall TMainFrm::SpeedButton11Click(TObject *Sender)
{
  MyCAD1->PopFromUndoRedoShapeList();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::Library1Click(TObject *Sender)
{
  LibShowFrm->Show();        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::SpeedButton12Click(TObject *Sender)
{
 OpenDialog1->InitialDir = ExtractFilePath(Application->ExeName) + "libs\\";
   if (OpenDialog1->Execute())

    if (FileExists(OpenDialog1->FileName))
      LibShowFrm->LoadLib(OpenDialog1->FileName);
     LibShowFrm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1DragOver(TObject *Sender, TObject *Source,
      int X, int Y, TDragState State, bool &Accept)
{
 Accept = dynamic_cast<TListView *>(Source);
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1DragDrop(TObject *Sender, TObject *Source,
      int X, int Y)
{
if (dynamic_cast<TListView *>(Source))
{          

     MyCAD1->AddUserDefineShapefromLib( LibShowFrm->mLibManager,
                                       LibShowFrm->mListView->Selected->Caption,
                                       X,Y,MyCAD1);
     MyCAD1->Refresh();
 }
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------





void __fastcall TMainFrm::ImageBitmap1Click(TObject *Sender)
{
  Graphics::TBitmap * ABitmap = new Graphics::TBitmap();

   ABitmap->LoadFromFile(ExtractFilePath(Application->ExeName)+"logo.bmp");
   MyCAD1-> AddImageShapeByCode("ImageShape",Point(20,30),ABitmap);
   ABitmap->Free();
}

//---------------------------------------------------------------------------

void __fastcall TMainFrm::MyCAD1ShapeAdded(TMyShape *&AShape,
      int ShapeCount)
{


Graphics::TBitmap * Mybitmap;

  if (AShape->ClassNameIs( "TMyImage"))//&& (AShapeShapeName.Pos("ImageShape")==0) )
    if (OpenPictureDialog1->Execute()){

      Mybitmap = new Graphics::TBitmap;
      Mybitmap->LoadFromFile(OpenPictureDialog1->FileName);
      MyCAD1->SetMyImage(AShape->ShapeId, Mybitmap) ;
      Mybitmap->Free();
    };
  if (AShape != NULL)
 {
  CADInspFrm->ComponentComboBox1->Root=MainFrm->MyCAD1;
  CADInspFrm->ComponentComboBox1->Instance=AShape;
  //CADInspFrm->ComponentInspector1->Instance=CADInspFrm->ComponentComboBox1->Instance;
 }        
}
//---------------------------------------------------------------------------

void __fastcall TMainFrm::AutoCADDXF1Click(TObject *Sender)
{
/*
 MyCAD1->SaveToDxf("C:\\TestCAD.dxf");
  ShowMessage("MyCAD1 has been saved to c:\\TestCAD.DXF !");
  */
   SaveDialog1->DefaultExt = 'dxf';
 SaveDialog1->Filter = "AutoCAD DXF R12|*.dxf|All Files|*.*";
 SaveDialog1->InitialDir = ExtractFilePath(Application->ExeName);
  if (SaveDialog1->Execute())
  {
    MyCAD1->SaveToDxf(SaveDialog1->FileName);
    ShowMessage("MyCAD1 has been saved to "+SaveDialog1->FileName);
  }
}
//---------------------------------------------------------------------------

